"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = exports.extractDynamicIdentifier = void 0;
const policy_1 = require("../interfaces/policy");
const constants_1 = require("./constants");
const helper_1 = require("./helper");
exports.extractDynamicIdentifier = (0, helper_1.dynamicIdentifierExtractor)(constants_1.ACTION_META_FIELD, {
    preHook(value, ctx) {
        if (!ctx || value !== constants_1.CTRL_ACTION_PLACEHOLDER) {
            return value;
        }
        const parts = [
            (ctx.getClass().name || '').replace(constants_1.CTRL_SERVICE_REGEXP, ''),
            ctx.getHandler().name,
        ];
        return parts
            .filter(Boolean)
            .map((part) => part.toLowerCase())
            .join(policy_1.DELIMITER);
    },
});
function Action(action) {
    return (target, key, descriptor) => {
        Reflect.defineMetadata(constants_1.ACTION_META_FIELD, action || constants_1.CTRL_ACTION_PLACEHOLDER, descriptor.value);
        return descriptor;
    };
}
exports.Action = Action;
