"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirewallGuard = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const decorator_error_1 = require("../errors/decorator.error");
const iacry_service_1 = require("../iacry.service");
const action_1 = require("./action");
const resource_1 = require("./resource");
const principal_1 = require("./principal");
let FirewallGuard = class FirewallGuard {
    constructor(service) {
        this.service = service;
    }
    async canActivate(context) {
        const action = (0, action_1.extractDynamicIdentifier)(context.getHandler(), context);
        const principal = (0, principal_1.extractDynamicIdentifier)(context.getHandler(), context);
        const resource = (0, resource_1.extractDynamicIdentifier)(context.getHandler(), context);
        if (!action || !principal) {
            throw new decorator_error_1.DecoratorError('You must decorate your controller with @IACryFirewall or at least @IACryAction and @IACryPrincipal decorators');
        }
        return this.service.isGranted(action, principal, resource || iacry_service_1.IACryService.ANY);
    }
};
FirewallGuard = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__metadata("design:paramtypes", [iacry_service_1.IACryService])
], FirewallGuard);
exports.FirewallGuard = FirewallGuard;
