import { PolicyInterface, Action, Resource, Principal, ActionObject, ResourceObject, PrincipalObject, DynamicIdentifier, DynamicIdentifierItem, DynamicIdentifierVector, ANY } from '../interfaces/policy';
import { Entity } from '../decorators/entity';
export declare abstract class CoreHelper {
    static readonly ANY: "*";
    static encode(policy: PolicyInterface, beatify?: boolean): string;
    static decode(rawPolicy: string): PolicyInterface;
    isDynamicVector(x: DynamicIdentifier<Action | Resource | Principal> | DynamicIdentifierVector<Action | Resource | Principal>): x is DynamicIdentifierVector<Action | Resource | Principal>;
    isDynamicItem(x: DynamicIdentifier<Action | Resource | Principal>): x is DynamicIdentifierItem<Action | Resource | Principal>;
    parseDynamicIdentifier(rawPolicy: PolicyInterface | any, prop: string, value: string | ANY): ActionObject | ResourceObject | PrincipalObject;
    normalizeDynamicIdentifier(thing: Resource | ResourceObject | Action | ActionObject | Principal | PrincipalObject, prop: string): ActionObject | ResourceObject | PrincipalObject;
    normalizeDynamicObject(thing: ActionObject | PrincipalObject | ResourceObject | Entity | Principal | Resource | Action | object, prop?: string): ActionObject | PrincipalObject | ResourceObject | Principal | Resource | Action;
}
