"use strict";
var IACryModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.IACryModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const iacry_service_1 = require("./iacry.service");
const constants_1 = require("./constants");
let IACryModule = IACryModule_1 = class IACryModule {
    static forRoot(options) {
        const OptionsProvider = {
            provide: constants_1.IACRY_OPTIONS,
            useValue: options,
        };
        return {
            module: IACryModule_1,
            providers: [OptionsProvider, iacry_service_1.IACryService],
            exports: [iacry_service_1.IACryService],
        };
    }
    static forRootAsync(options) {
        const providers = this.createAsyncProviders(options);
        return {
            module: IACryModule_1,
            providers: [...providers, iacry_service_1.IACryService],
            imports: options.imports,
            exports: [iacry_service_1.IACryService],
        };
    }
    static createAsyncProviders(options) {
        const providers = [this.createAsyncOptionsProvider(options)];
        if (options.useClass) {
            providers.push({
                provide: options.useClass,
                useClass: options.useClass,
            });
        }
        return providers;
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                name: constants_1.IACRY_OPTIONS,
                provide: constants_1.IACRY_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            name: constants_1.IACRY_OPTIONS,
            provide: constants_1.IACRY_OPTIONS,
            useFactory: async (optionsFactory) => {
                return optionsFactory.createOptions();
            },
            inject: [options.useExisting || options.useClass],
        };
    }
};
IACryModule = IACryModule_1 = tslib_1.__decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], IACryModule);
exports.IACryModule = IACryModule;
