import { CoreHelper } from './helpers/core';
import { PolicyStorage } from './interfaces/policy-storage';
import { PolicyInterface, Action, ActionObject, Resource, ResourceObject, Principal, PrincipalObject, Effect } from './interfaces/policy';
import { Entity } from './decorators/entity';
export declare class PolicyManager extends CoreHelper {
    protected storage?: PolicyStorage;
    constructor(storage?: PolicyStorage);
    setStorage(storage: PolicyStorage): PolicyManager;
    attach(rawPrincipal: Principal | PrincipalObject | Entity | object, rawPolicies?: Array<string | PolicyInterface>): Promise<number>;
    reset(rawPrincipal: Principal | PrincipalObject | Entity | object, rawPolicies?: Array<string | PolicyInterface>): Promise<number>;
    retrieve(rawPrincipal: Principal | PrincipalObject | Entity | object): Promise<Array<PolicyInterface>>;
    retrieveBySid(sid: string, rawPrincipal: Principal | PrincipalObject | Entity | object): Promise<Array<PolicyInterface>>;
    upsertBySid(sid: string, rawPrincipal: Principal | PrincipalObject | Entity | object, rawPolicies?: Array<string | PolicyInterface>): Promise<number>;
    grant(rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject | Entity | object, rawResource?: Resource | ResourceObject | Entity | object, effect?: Effect, sid?: string): Promise<number>;
}
