"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IoRedis = void 0;
class IoRedis {
    constructor(client) {
        this.client = client;
        this.SUCCESS = 'OK';
        this.EXPIRE = 'EX';
    }
    async set(key, value, expire) {
        if (!expire) {
            return (await this.client.set(key, value)) === this.SUCCESS;
        }
        return ((await this.client.set(key, value, this.EXPIRE, expire)) === this.SUCCESS);
    }
    async has(key) {
        return (await this.client.exists(key)) === 1;
    }
    async get(key) {
        return this.client.get(key);
    }
    async remove(key) {
        return (await this.client.del(key)) === 1;
    }
}
exports.IoRedis = IoRedis;
