"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalStorage = void 0;
const iacry_error_1 = require("../errors/iacry.error");
class GlobalStorage {
    constructor(policies = []) {
        this.policies = policies;
        this.readonly = true;
    }
    async fetch(_principal) {
        return this.policies;
    }
    async fetchBySid(_sid, _principal) {
        return [];
    }
    async save(_principal, rawPolicies) {
        this.policies = [...rawPolicies];
        return rawPolicies.length;
    }
    async add(_principal, rawPolicies) {
        this.policies = [...this.policies, ...rawPolicies];
        return rawPolicies.length;
    }
    async purge(_principal) {
        const removedCount = this.policies.length;
        this.policies = [];
        return removedCount;
    }
    saveBySid(_sid, _principal, _rawPolicies) {
        throw this.DisallowedException('saveBySid');
    }
    DisallowedException(method) {
        return new iacry_error_1.BaseError(`PolicyInterface Storage method ${method}() invocation not allowed`);
    }
}
exports.GlobalStorage = GlobalStorage;
