"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequelizeStorage = void 0;
class SequelizeStorage {
    constructor(storageRepository) {
        this.storageRepository = storageRepository;
        this.readonly = false;
    }
    async fetch(principal) {
        return this.repository.findByPrincipal(principal);
    }
    async fetchBySid(sid, principal) {
        return this.repository.findByPrincipal(principal, sid);
    }
    async save(principal, rawPolicies) {
        return this.repository.savePrincipalPolicies(principal, rawPolicies, false);
    }
    async add(principal, rawPolicies) {
        return this.repository.savePrincipalPolicies(principal, rawPolicies, true);
    }
    saveBySid(sid, principal, rawPolicies) {
        return this.repository.savePrincipalPolicies(principal, rawPolicies, false, sid);
    }
    async purge(principal) {
        return this.repository.destroyByPrincipal(principal);
    }
    get repository() {
        if (!this.isStorageModel(this.storageRepository)) {
            throw new TypeError('Policies repository must extend Sequelize PoliciesStorage model');
        }
        return this.storageRepository;
    }
    isStorageModel(x) {
        return (typeof x === 'function' &&
            typeof x.findByPrincipal === 'function' &&
            typeof x.savePrincipalPolicies === 'function' &&
            typeof x.destroyByPrincipal === 'function');
    }
}
exports.SequelizeStorage = SequelizeStorage;
