import { Model } from 'sequelize-typescript';
import { PrincipalObject, PolicyInterface } from '../../interfaces/policy';
export declare class PoliciesStorage<T> extends Model<PoliciesStorage<T>> implements PrincipalObject {
    pk: number;
    sid: string;
    id: string;
    entity: string;
    policy: string;
    createdAt: Date;
    updatedAt: Date;
    static savePrincipalPolicies(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>, attach: boolean, sid?: string): Promise<number>;
    static destroyByPrincipal(principal: PrincipalObject, sid?: string): Promise<number>;
    static findByPrincipal(principal: PrincipalObject, sid?: string): Promise<Array<string>>;
    private static rawPolicyToPayload;
    private static normalizePolicyItem;
}
